## libuvc 0.0.6

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project(libuvc)

if (NOT CMAKE_BUILD_TYPE)
  message(STATUS "No build type selected, default to Release")
  set(CMAKE_BUILD_TYPE "Release" CACHE STRING "" FORCE)
endif ()

if (NOT CMAKE_BUILD_TARGET)
  message(STATUS "No target type selected, default to both shared and static library")
  set(CMAKE_BUILD_TARGET "Both" CACHE STRING "" FORCE)
endif()

set(libuvc_VERSION_MAJOR 0)
set(libuvc_VERSION_MINOR 0)
set(libuvc_VERSION_PATCH 6)
set(libuvc_VERSION ${libuvc_VERSION_MAJOR}.${libuvc_VERSION_MINOR}.${libuvc_VERSION_PATCH})

set(libuvc_DESCRIPTION "A cross-platform library for USB video devices")
set(libuvc_URL "https://github.com/ktossell/libuvc")

find_package(PkgConfig)
pkg_check_modules(LIBUSB libusb-1.0)

# Try to find JPEG using a module or pkg-config. If that doesn't work, search for the header.
find_package(jpeg QUIET)
if(JPEG_FOUND)
  set(JPEG_LINK_FLAGS ${JPEG_LIBRARIES})
else()
  pkg_check_modules(JPEG QUIET libjpeg)
  if(JPEG_FOUND)
      set(JPEG_INCLUDE_DIR ${JPEG_INCLUDE_DIRS})
      set(JPEG_LINK_FLAGS ${JPEG_LDFLAGS})
  else()
    find_path(JPEG_INCLUDE_DIR jpeglib.h)
    if(JPEG_INCLUDE_DIR)
      set(JPEG_FOUND ON)
      set(JPEG_LINK_FLAGS -ljpeg)
    endif()
  endif()
endif()

include(GNUInstallDirs)

SET(CMAKE_C_FLAGS_DEBUG "-g -DUVC_DEBUGGING")

SET(INSTALL_CMAKE_DIR "${CMAKE_INSTALL_PREFIX}/lib/cmake/libuvc" CACHE PATH
	"Installation directory for CMake files")

SET(SOURCES src/ctrl.c src/ctrl-gen.c src/device.c src/diag.c
           src/frame.c src/init.c src/stream.c
           src/misc.c)

include_directories(
  ${libuvc_SOURCE_DIR}/include
  ${libuvc_BINARY_DIR}/include
  ${LIBUSB_INCLUDE_DIRS}
)

if(JPEG_FOUND)
  message(STATUS "Building libuvc with JPEG support.")
  include_directories(${JPEG_INCLUDE_DIR})
  SET(LIBUVC_HAS_JPEG TRUE)
  SET(SOURCES ${SOURCES} src/frame-mjpeg.c)
else()
  message(WARNING "JPEG not found. libuvc will not support JPEG decoding.")
endif()

if(${CMAKE_BUILD_TARGET} MATCHES "Shared")
  set(BUILD_UVC_SHARED TRUE)
elseif(${CMAKE_BUILD_TARGET} MATCHES "Static")
  set(BUILD_UVC_STATIC TRUE)
elseif(${CMAKE_BUILD_TARGET} MATCHES "Both")
  set(BUILD_UVC_SHARED TRUE)
  set(BUILD_UVC_STATIC TRUE)
else()
  message( FATAL_ERROR "Invalid build type ${CMAKE_BUILD_TARGET}" )
endif()

if(BUILD_UVC_SHARED)
  add_library(uvc SHARED ${SOURCES})
  list(APPEND UVC_TARGETS uvc)
endif()

if(BUILD_UVC_STATIC)
  add_library(uvc_static STATIC ${SOURCES})
  set_target_properties(uvc_static PROPERTIES OUTPUT_NAME uvc)
  list(APPEND UVC_TARGETS uvc_static)
endif()

configure_file(include/libuvc/libuvc_config.h.in
  ${PROJECT_BINARY_DIR}/include/libuvc/libuvc_config.h @ONLY)

foreach(target_name ${UVC_TARGETS})
  set_target_properties(${target_name} PROPERTIES
    PUBLIC_HEADER "include/libuvc/libuvc.h;${libuvc_BINARY_DIR}/include/libuvc/libuvc_config.h" )
endforeach()

if(BUILD_UVC_SHARED)
  if(JPEG_FOUND)
    target_link_libraries (uvc ${JPEG_LINK_FLAGS})
  endif(JPEG_FOUND)

  target_link_libraries(uvc ${LIBUSB_LIBRARIES})

  #add_executable(test src/test.c)
  #target_link_libraries(test uvc ${LIBUSB_LIBRARIES} opencv_highgui
  #  opencv_core)
endif()

install(TARGETS ${UVC_TARGETS}
    EXPORT libuvcTargets
  LIBRARY DESTINATION "${CMAKE_INSTALL_PREFIX}/lib/${CMAKE_LIBRARY_ARCHITECTURE}"
  ARCHIVE DESTINATION "${CMAKE_INSTALL_PREFIX}/lib/${CMAKE_LIBRARY_ARCHITECTURE}"
  PUBLIC_HEADER DESTINATION "${CMAKE_INSTALL_PREFIX}/include/libuvc"
)

export(TARGETS ${UVC_TARGETS}
  FILE "${PROJECT_BINARY_DIR}/libuvcTargets.cmake")
export(PACKAGE libuvc)

set(CONF_INCLUDE_DIR "${CMAKE_INSTALL_PREFIX}/include")
set(CONF_LIBRARY_DIR "${CMAKE_INSTALL_PREFIX}/lib/${CMAKE_LIBRARY_ARCHITECTURE}")
set(CONF_LIBRARY "${CMAKE_INSTALL_PREFIX}/lib/${CMAKE_LIBRARY_ARCHITECTURE}/${CMAKE_SHARED_LIBRARY_PREFIX}uvc${CMAKE_SHARED_LIBRARY_SUFFIX}")

configure_file(libuvcConfig.cmake.in ${PROJECT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/libuvcConfig.cmake)

configure_file(libuvcConfigVersion.cmake.in ${PROJECT_BINARY_DIR}/libuvcConfigVersion.cmake @ONLY)

configure_file(libuvc.pc.in ${PROJECT_BINARY_DIR}/libuvc.pc @ONLY)

install(FILES
  "${PROJECT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/libuvcConfig.cmake"
  "${PROJECT_BINARY_DIR}/libuvcConfigVersion.cmake"
  DESTINATION "${INSTALL_CMAKE_DIR}")

install(EXPORT libuvcTargets
  DESTINATION "${INSTALL_CMAKE_DIR}")

install(FILES
  "${PROJECT_BINARY_DIR}/libuvc.pc"
  DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig"
)

=== debian/changelog ===
libuvc (0.0.6-2) unstable; urgency=medium

  [ Ondřej Nový ]
  * d/control: Set Vcs-* to salsa.debian.org
  * Use debhelper-compat instead of debian/compat

  [ Felipe Sateler ]
  * Change maintainer address to debian-multimedia@lists.debian.org

  [ IOhannes m zmölnig ]
  * Use execute_before_dh_* rather than override_dh_*
  * Use d/clean for cleanup
  * Skip dh_auto_install for arch:all
  * Declare that building this package does not require 'root' powers.
  * Modernize 'licensecheck' target
    + Re-generate d/copyright_hints
  * Add salsa-ci configuration
  * Apply 'wrap-and-sort -ast'
  * Bump dh-compat to 13
  * Bump standards version to 4.6.1

  [ Debian Janitor ]
  * Apply multi-arch hints. + libuvc0: Add Multi-Arch: same.

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Thu, 08 Dec 2022 23:50:16 +0100

libuvc (0.0.6-1.1) unstable; urgency=medium

  * Non maintainer upload by the Reproducible Builds team.
  * No source change upload to rebuild on buildd with .buildinfo files.

 -- Holger Levsen <holger@debian.org>  Sun, 03 Jan 2021 15:19:51 +0100

libuvc (0.0.6-1) unstable; urgency=medium

  * Initial release (Closes: #877226)

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Fri, 29 Sep 2017 23:37:42 +0200

=== debian/control ===
Source: libuvc
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>,
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 libjpeg-dev,
 libusb-1.0-0-dev,
 pkg-config,
Build-Depends-Indep:
 doxygen,
Standards-Version: 4.6.1
Rules-Requires-Root: no
Section: devel
Homepage: https://github.com/ktossell/libuvc
Vcs-Git: https://salsa.debian.org/multimedia-team/libuvc.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/libuvc

Package: libuvc-dev
Section: libdevel
Architecture: any
Depends:
 libuvc0 (= ${binary:Version}),
 ${misc:Depends},
Description: cross-platform library for USB video devices - development files
 libuvc is a cross-platform library for USB video devices, built atop libusb.
 It enables fine-grained control over USB video devices exporting the
 standard USB Video Class (UVC) interface, enabling developers to write
 drivers for previously unsupported devices, or just access UVC devices in a
 generic fashion.
 .
 This package contains the files necessary to compile applications using
 libuvc.

Package: libuvc0
Section: libs
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Multi-Arch: same
Description: cross-platform library for USB video devices
 libuvc is a cross-platform library for USB video devices, built atop libusb.
 It enables fine-grained control over USB video devices exporting the
 standard USB Video Class (UVC) interface, enabling developers to write
 drivers for previously unsupported devices, or just access UVC devices in a
 generic fashion.
 .
 This package contains the shared objects necessary to run an application using
 libuvc.

Package: libuvc-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Suggests:
 libuvc-dev,
Built-Using:
 ${doxygen:Built-Using},
Description: cross-platform library for USB video devices - documentation
 libuvc is a cross-platform library for USB video devices, built atop libusb.
 It enables fine-grained control over USB video devices exporting the
 standard USB Video Class (UVC) interface, enabling developers to write
 drivers for previously unsupported devices, or just access UVC devices in a
 generic fashion.
 .
 This package contains the html documentation for the libuvc API.

=== debian/watch ===
# See uscan
# Compulsory line, this is a version 4 file
version=4

# GitHub hosted projects
opts="dversionmangle=s/[~+](dfsg|repack)([.]?[0-9]*)?$//,filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%libuvc-$1.tar.gz%" \
   https://github.com/ktossell/libuvc/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## libuvc 0.0.7

=== debian/changelog ===
libuvc (0.0.7-4) unstable; urgency=medium

  * Team upload.
  * cmake: Set minimum required version to 3.5 for CMake 4+ compatibility
    (Closes: #1113214)

 -- Jochen Sprickerhof <jspricke@debian.org>  Thu, 23 Oct 2025 11:08:31 +0200

libuvc (0.0.7-3) unstable; urgency=medium

  * Team upload.
  * Move -dev dependencies to -dev package.
    Thanks to Simon McVittie (Closes: #1105774)

 -- Jochen Sprickerhof <jspricke@debian.org>  Wed, 14 May 2025 18:18:21 +0200

libuvc (0.0.7-2) unstable; urgency=medium

  * Team upload.
  * Add dependencies of -dev package
  * pkg-config => pkgconf

 -- Jochen Sprickerhof <jspricke@debian.org>  Fri, 11 Oct 2024 16:08:02 +0200

libuvc (0.0.7-1) unstable; urgency=medium

  * New upstream version 0.0.7
    + Drop patches applied upstream
  * Fix installation path for cmake snippets
  * Update symbols file for libuvc0
    + Add new symbols to d/libuvc0.symbols
    + Add Build-Depends-Package to symbols file
  * Use 'dh-sequence-doxygen'
  * Update copyright information
    + Bump copyright dates
    + Drop stray '.git*'-stanza from d/copyright
    + Re-generate d/copyright_hints
  * Bump standards version to 4.6.2

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Mon, 29 Jan 2024 15:52:40 +0100

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
export DEB_LDFLAGS_MAINT_APPEND = \
	-Wl,--as-needed \
	-Wl,--version-script=$(CURDIR)/debian/libuvc.ver


%:
	dh $@

override_dh_auto_build-indep:
	doxygen doxygen.conf

override_dh_auto_install-indep:

execute_before_dh_install-indep:
	-dh_doxygen doc/

DEB_COPYRIGHT_CHECK_IGNORE_REGEX = \
        debian/.*
# licensecheck v1
.PHONY: licensecheck
licensecheck:
	LANG=C.UTF-8 licensecheck \
		-i "^($(DEB_COPYRIGHT_CHECK_IGNORE_REGEX))$$" \
		--check '.*' --recursive --deb-machine --lines 0 * \
		> debian/copyright_newhints
	cmp debian/copyright_hints debian/copyright_newhints \
		&& rm debian/copyright_newhints
